/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 4 dec. 2006 10:44:30
import java.math.BigDecimal;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

import org.cocktail.carambole.server.MyAjaxPage;
import org.cocktail.carambole.server.NavigationCtrl;
import org.cocktail.fwkcktlajaxwebext.serveur.CocktailAjaxSession;
import org.cocktail.fwkcktldepense.server.exception.FactoryException;
import org.cocktail.fwkcktldepense.server.factory.FactoryArticle;
import org.cocktail.fwkcktldepense.server.finder.FinderArticle;
import org.cocktail.fwkcktldepense.server.finder.FinderAttribution;
import org.cocktail.fwkcktldepense.server.finder.FinderCtrlSeuilMAPA;
import org.cocktail.fwkcktldepense.server.finder.FinderFournisseur;
import org.cocktail.fwkcktldepense.server.finder.FinderTva;
import org.cocktail.fwkcktldepense.server.finder.FinderTypeAchat;
import org.cocktail.fwkcktldepense.server.finder.FinderUtilisateurFonction;
import org.cocktail.fwkcktldepense.server.metier.EOArticle;
import org.cocktail.fwkcktldepense.server.metier.EOAttribution;
import org.cocktail.fwkcktldepense.server.metier.EOCodeExer;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EOCtrlSeuilMAPA;
import org.cocktail.fwkcktldepense.server.metier.EOFonction;
import org.cocktail.fwkcktldepense.server.metier.EOFournisseur;
import org.cocktail.fwkcktldepense.server.metier.EOTva;
import org.cocktail.fwkcktldepense.server.metier.EOTypeAchat;
import org.cocktail.fwkcktldepense.server.metier.b2b.EOFournisB2bCxmlParam;
import org.cocktail.fwkcktldepense.server.util.ZStringUtil;
import org.cocktail.fwkcktldroitsutils.common.util.MyStringCtrl;
import org.cocktail.fwkcktlpersonne.common.metier.EOFournis;

import com.webobjects.appserver.WOActionResults;
import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WODisplayGroup;
import com.webobjects.appserver.WOResponse;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.eocontrol.EOQualifier;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;
import com.webobjects.foundation.NSMutableDictionary;
import com.webobjects.foundation.NSTimestamp;

import er.extensions.eof.ERXQ;
import er.extensions.foundation.ERXSimpleTemplateParser;
import er.extensions.validation.ERXValidationException;
import er.extensions.validation.ERXValidationFactory;

public class ArticleCreation extends MyAjaxPage {

	private static final long serialVersionUID = 1L;
	private FactoryArticle fa = null;
	private boolean isAfficherListeFournisseur = false;
	private String avertissement = null;

	private boolean isCmdeMarche = false;
	//public NSArray lesCodesNomenclature = null;
	private boolean isTypeAchatHorsMarche = false, isTypeAchatMonopole = false, isTypeAchat3cmp = false, isTypeAchatSansAchat = false;

	private String filterTextAttribution = "";
	public NSArray<EOAttribution> attributionsValides = null;
	private EOAttribution uneAttributionValide = null;
	private EOAttribution uneAttributionValideSelectionnee = null;

	private NSArray<EOTypeAchat> typesAchatPossibles = null;
	private EOTypeAchat unTypeAchatPossible = null, unTypeAchatPossibleSelectionne = null;

	private String rechercheRapide = "";
	private boolean isRecherchePersonneMorale = true;
	private boolean isRechercheFournisseurInterne = false;
	private NSArray<NSDictionary<String, Object>> lesFournisseurs = null, lesFournisseursPossiblesPourCodeExer = null;
	private EOFournisseur unFournisseurSelectionne = null;
	private NSDictionary<String, Object> unFournisseur = null, unFournisseurDicoSelectionne = null;

	private String filterTextCodeNomenclature = "";
	private EOCodeExer unCodeNomenclature = null, unCodeNomenclatureSelectionne = null;
	private NSArray<EOCtrlSeuilMAPA> lesSeuilsMAPA = null;
	private EOCtrlSeuilMAPA unSeuilMAPA = null, unSeuilMAPASelectionne = null;

	//public String newArtLibelle = null, newArtReference = null;
	private boolean isCatalogue = false;

	private boolean modificationEnCours = false;
	private BigDecimal newArtPrixHt, newArtPrixTtc, newArtQte;
	private NSArray<EOTva> lesTauxTVA = null;
	public EOTva unTauxTVA = null;
	private EOTva newArtTva = null;

	private EOArticle newArticle = null;
	//Rod b2b
	public EOFournisB2bCxmlParam unB2bFournisParam;
	private Boolean isAfficherB2b = null;

	public ArticleCreation(WOContext context) {
		super(context);
		fa = new FactoryArticle();
	}

	public void appendToResponse(WOResponse response, WOContext context) {
		super.appendToResponse(response, context);
	}

	public void initialiser() {
		EOCommande commande = laCommandeEnCours();
		EOFournisseur fournisseur = commande.fournisseur();
		setUnTypeAchatPossibleSelectionne(commande.typeAchat());
		if (fournisseur != null) {
			setUnFournisseurSelectionne(fournisseur);
		}
		EOAttribution attribution = commande.attribution();
		if (attribution != null) {
			isCmdeMarche = true;
			attributionsValides = new NSArray<EOAttribution>(attribution);
			setUneAttributionValideSelectionnee(attribution);
		}
	}

	public WOComponent annuler() {
		BonDeCommande2 nextPage = NavigationCtrl.goToBonDeCommande(context(), null, null, null);

		EOArticle article = getNewArticle();
		if (article != null) {
			EOCommande commande = laCommandeEnCours();
			if (commande.commNumero() == null && (commande.articles() == null || commande.articles().count() == 0)) {
				commande.setFournisseurRelationship(null);

				resetAttributions();
				resetTypesAchat();
				unSeuilMAPASelectionne = null;
				unCodeNomenclatureSelectionne = null;
				lesFournisseurs = null;
				lesFournisseursPossiblesPourCodeExer = null;
				typesAchatPossibles = null;
				attributionsValides = null;
			}

			nextPage.setLaCommande(commande);
			nextPage.setSelectedTab("Articles");
		}

		return nextPage;
	}

	public boolean isAjouterDisabled() {
		boolean isAjouterDisabled = true;
		EOArticle article = getNewArticle();
		if (getUnCodeNomenclatureSelectionne() != null &&
				(getUnTypeAchatPossibleSelectionne() != null || getUneAttributionValideSelectionnee() != null) &&
				getUnFournisseurSelectionne() != null &&
				article.artLibelle() != null && article.artLibelle().length() > 0 && !isArtLibelleTooLarge()) {
			isAjouterDisabled = false;
		}
		return isAjouterDisabled;
	}

	public Boolean isArtLibelleTooLarge() {
		return getNewArticle() != null && getNewArticle().artLibelle() != null && getNewArticle().artLibelle().length() > getNewArticle().maxLengthForAttribute(EOArticle.ART_LIBELLE_KEY);
	}

	public WOComponent ajouter() {
		EOCommande commande = laCommandeEnCours();
		EOArticle article = getNewArticle();
		if (article != null) {
			try {
				article.setIsCatalogable(isCatalogue());
				EOEditingContext ed = commande.editingContext();
				session.factoryCommande.ajouterArticle(ed, commande, getUnFournisseurSelectionne(), article, getUneAttributionValideSelectionnee(), getUnTypeAchatPossibleSelectionne());
				if (ZStringUtil.isEmpty(commande.commLibelle())) {
					commande.setCommLibelle(article.artLibelle());
				}
			} catch (FactoryException e) {
				session.setAlertMessage(e.getMessageFormatte());
			} catch (RuntimeException e1) {
				e1.printStackTrace();
				throw e1;
			}
		}

		return NavigationCtrl.goToSavedBonDeCommande(session, commande, null, "Articles");
	}

	public void selectTypeAchat() {
		if (isCmdeMarche && attributionsValides != null && attributionsValides.count() == 1) {
			setUneAttributionValideSelectionnee((EOAttribution) attributionsValides.lastObject());
		}
		else if (lesFournisseursPossiblesPourCodeExer != null && lesFournisseursPossiblesPourCodeExer.count() > 0) {
			lesFournisseurs = lesFournisseursPossiblesPourCodeExer;
			if (lesFournisseurs.count() == 1) {
				NSDictionary<String, Object> fournisseur = lesFournisseurs.lastObject();
				String fouCode = (String) fournisseur.objectForKey("CODE");
				EOFournisseur leFournisseur = FinderFournisseur.getFournisseur(laCommandeEnCours().editingContext(), fouCode);
				setUnFournisseurSelectionne(leFournisseur);
			}
		}
		else {
			unFournisseurSelectionne = null;
			unFournisseurDicoSelectionne = null;
			lesFournisseurs = null;
		}
	}

	public void selectAttribution() {
	}

	public WOComponent rechercherUnFournisseur() {
		Boolean pm = null, fi = null;
		if (isRecherchePersonneMorale()) {
			pm = Boolean.TRUE;
		}
		else {
			pm = Boolean.FALSE;
		}

		if (isRechercheFournisseurInterne()) {
			fi = Boolean.TRUE;
		}
		else {
			fi = Boolean.FALSE;
		}
		//		lesFournisseurs = FinderFournisseur.getFournisseursForRechercheGlobale(laCommandeEnCours().editingContext(), rechercheRapide, pm);
		//		if (lesFournisseurs.count()==1) {
		//			isAfficherListeFournisseur=false;
		//			setUnFournisseurSelectionne((EOFournisseur)lesFournisseurs.lastObject());
		//			lesFournisseurs = null;
		//		} else if (lesFournisseurs.count()==0) {
		//			isAfficherListeFournisseur=false;
		//			session.setAlertMessage("Aucun fournisseur ne correspond à cette recherche.");
		//		} else {
		//			isAfficherListeFournisseur=true;
		//		}
		NSMutableDictionary<String, Object> bindings = new NSMutableDictionary<String, Object>();
		bindings.setObjectForKey(rechercheRapide, "rechercheGlobale");
		bindings.setObjectForKey(pm, "personneMorale");
		if (fi != null) {
			bindings.setObjectForKey(fi, "fournisseurInterne");
		}
		EOEditingContext ed = laCommandeEnCours().editingContext();
		int nbreFournisseurs = FinderFournisseur.getRawRowCountFournisseurs(ed, bindings);
		if (nbreFournisseurs > 0) {
			lesFournisseurs = FinderFournisseur.getRawRowFournisseurs(ed, bindings);
			if (lesFournisseurs.count() == 1) {
				isAfficherListeFournisseur = false;
				NSDictionary<String, Object> fournisseur = lesFournisseurs.lastObject();
				String fouCode = (String) fournisseur.objectForKey("CODE");
				EOFournisseur leFournisseur = FinderFournisseur.getFournisseur(ed, fouCode);
				setUnFournisseurSelectionne(leFournisseur);
				lesFournisseurs = null;
			}
			else {
				isAfficherListeFournisseur = true;
			}
		}
		else {
			isAfficherListeFournisseur = false;
			session.setAlertMessage("Aucun fournisseur ne correspond à cette recherche.");
		}

		return null;
	}

	public WOComponent selectFournisseur() {
		return null;
	}

	public void selectionnerFournisseur() {
		NSDictionary<String, Object> fournisseur = getUnFournisseur();
		String fouCode = (String) fournisseur.objectForKey("CODE");
		EOFournisseur leFournisseur = FinderFournisseur.getFournisseur(laCommandeEnCours().editingContext(), fouCode);
		setUnFournisseurSelectionne(leFournisseur);
		lesFournisseurs = null;
		isAfficherListeFournisseur = false;
	}

	public WOComponent modifierLaRecherche() {
		lesFournisseurs = null;
		isAfficherListeFournisseur = false;
		return null;
	}

	public WOComponent selectCodeNomenclature() {
		EOCtrlSeuilMAPA unSeuil = getUnSeuilMAPASelectionne();
		// session.setDernierCodeNomenclatureUtilise(unCodeNomenclatureSelectionne);
		EOCommande commande = laCommandeEnCours();
		EOEditingContext edc = commande.editingContext();
		lesFournisseurs = null;
		attributionsValides = null;
		typesAchatPossibles = null;
		setAvertissement(null);
		if (unSeuil != null && (commande.articles() == null || commande.articles().count() == 0)) {
			resetTypesAchat();
			resetAttributions();
			isCmdeMarche = false;

			//fournisseur deja affecte a la commande (si attributions ou mmonopole, 3cmp etc., trouvees pour CN, on supprime le fournisseur de la commande)
			if (commande.fournisseur() != null) {
				boolean viderFournisseur = false;
				NSDictionary<String, Object> bdgs = new NSDictionary<String, Object>(unCodeNomenclatureSelectionne, "codeExer");
				lesFournisseursPossiblesPourCodeExer = FinderFournisseur.getRawRowFournisseurs(edc, bdgs);
				if (lesFournisseursPossiblesPourCodeExer == null || lesFournisseursPossiblesPourCodeExer.count() == 0) {
					// Calcul des attributions possibles pour le cn selectionne
					NSMutableDictionary<String, Object> bindings = new NSMutableDictionary<String, Object>();
					bindings.setObjectForKey(new NSTimestamp(), "date");
					bindings.setObjectForKey(unCodeNomenclatureSelectionne, "codeExer");
					attributionsValides = FinderAttribution.getAttributionsValides(edc, bindings);
					if (attributionsValides != null && attributionsValides.count() > 0) {
						viderFournisseur = true;
					}
				}
				else {
					viderFournisseur = true;
				}
				if (viderFournisseur) {
					commande.setFournisseurRelationship(null);
					unFournisseurSelectionne = null;
					unFournisseurDicoSelectionne = null;
				}
			}

			if (commande.fournisseur() == null) {
				// Calcul des fournisseurs possibles pour le cn selectionne
				unFournisseurSelectionne = null;
				rechercheRapide = null;
				NSDictionary<String, Object> bdgs = new NSDictionary<String, Object>(unCodeNomenclatureSelectionne, "codeExer");
				lesFournisseursPossiblesPourCodeExer = FinderFournisseur.getRawRowFournisseurs(edc, bdgs);
				if (lesFournisseursPossiblesPourCodeExer == null || lesFournisseursPossiblesPourCodeExer.count() == 0) {
					// Calcul des attributions possibles pour le cn selectionne
					NSMutableDictionary<String, Object> bindings = new NSMutableDictionary<String, Object>();
					bindings.setObjectForKey(new NSTimestamp(), "date");
					bindings.setObjectForKey(unCodeNomenclatureSelectionne, "codeExer");
					attributionsValides = FinderAttribution.getAttributionsValides(edc, bindings);
				}

				if (lesFournisseursPossiblesPourCodeExer != null && lesFournisseursPossiblesPourCodeExer.count() > 0) {
					lesFournisseurs = lesFournisseursPossiblesPourCodeExer;
					if (lesFournisseurs != null && lesFournisseurs.count() == 1) {
						NSDictionary<String, Object> fournisseur = lesFournisseurs.lastObject();
						String fouCode = (String) fournisseur.objectForKey("CODE");
						EOFournisseur leFournisseur = FinderFournisseur.getFournisseur(edc, fouCode);
						setUnFournisseurSelectionne(leFournisseur);
					}
				}
				else {
					unFournisseurSelectionne = null;
					unFournisseurDicoSelectionne = null;
				}
			}

			// Calcul des types achat possibles pour le cn selectionne
			typesAchatPossibles = FinderTypeAchat.getTypeAchats(edc, unCodeNomenclatureSelectionne);
			if (typesAchatPossibles != null && typesAchatPossibles.count() > 0) {
				if (typesAchatPossibles.count() == 1) {
					setUnTypeAchatPossibleSelectionne((EOTypeAchat) typesAchatPossibles.lastObject());
				}
			}
			if (attributionsValides != null && attributionsValides.count() > 0) {
				resetTypesAchat();
				isCmdeMarche = true;
				setAvertissement(null);
				if (attributionsValides.count() == 1) {
					setUneAttributionValideSelectionnee((EOAttribution) attributionsValides.lastObject());
				}
			}
		}
		else {
			setAvertissement(null);
			lesFournisseursPossiblesPourCodeExer = null;
			lesFournisseurs = null;
			attributionsValides = null;
			typesAchatPossibles = null;
			if (commande.fournisseur() != null && unCodeNomenclatureSelectionne != null) {
				// Calcul des attributions possibles pour le cn selectionne
				NSMutableDictionary<String, Object> bindings = new NSMutableDictionary<String, Object>();
				bindings.setObjectForKey(new NSTimestamp(), "date");
				bindings.setObjectForKey(unCodeNomenclatureSelectionne, "codeExer");
				attributionsValides = FinderAttribution.getAttributionsValides(edc, bindings);
				// Calcul des types achat possibles pour le cn selectionne
				typesAchatPossibles = FinderTypeAchat.getTypeAchats(edc, unCodeNomenclatureSelectionne);
			}
		}

		if (isTypeAchatHorsMarche() && unSeuil != null && unSeuil.montantEngageHt().floatValue() > unSeuil.seuilMin().floatValue()) {
			setAvertissement("ATTENTION! Le seuil de " + unSeuil.seuilMin().floatValue() + "&euro; est d&eacute;pass&eacute; sur ce code de nomenclature. Vous entrez dans un M&agrave;PA!");
		}

		return null;
	}

	public void neFaitRien() {

	}

	public WOActionResults checkLongueurs() {
		try {
			if (getNewArticle() != null) {
				getNewArticle().checkLongueursMax();
			}
		} catch (Exception e) {
			session.addSimpleErrorMessage("Erreur", e);
		}
		return null;
	}

	public void submitPrix() {
		modificationEnCours = false;
		if (!isCmdeMarche()) {
			verificationMAPA();
		}
	}

	private void resetTypesAchat() {
		unTypeAchatPossibleSelectionne = null;
		isCmdeMarche = false;
		isTypeAchatHorsMarche = false;
		isTypeAchatMonopole = false;
		isTypeAchat3cmp = false;
		isTypeAchatSansAchat = false;
	}

	private void resetAttributions() {
		setUneAttributionValideSelectionnee(null);
		filterTextAttribution = "";
	}

	public boolean isCmdeMarcheDisabled() {
		boolean isCmdeMarcheDisabled = true;
		EOCommande commande = laCommandeEnCours();
		//    	if (commande.typeAchat()==null &&
		//        		commande.attribution()==null &&
		//        		attributionsValides!=null && 
		//        		attributionsValides.count()>0)	{
		//        		isCmdeMarcheDisabled = false;
		//        	}
		if (commande.fournisseur() == null &&
				attributionsValides != null && attributionsValides.count() > 0) {
			isCmdeMarcheDisabled = false;
		}

		return isCmdeMarcheDisabled;
	}

	public boolean isCmdeMarche() {
		return isCmdeMarche;
	}

	public void setIsCmdeMarche(boolean isCmdeMarche) {
		if (this.isCmdeMarche != isCmdeMarche) {
			if (isCmdeMarche) {
				resetTypesAchat();
				setAvertissement(null);
			}
			this.isCmdeMarche = isCmdeMarche;
		}
	}

	public boolean isTypeAchatHorsMarcheDisabled() {
		boolean isTypeAchatHorsMarcheDisabled = true;
		EOCommande commande = laCommandeEnCours();
		if (commande.fournisseur() == null &&
				typesAchatPossibles != null && typesAchatPossibles.count() > 0) {
			@SuppressWarnings("unchecked")
			NSArray<String> libelles = (NSArray<String>) typesAchatPossibles.valueForKeyPath("typaLibelle");
			if (libelles.containsObject(EOTypeAchat.MARCHE_NON_FORMALISE)) {
				if (!isCmdeMarche || mySession().autoriserCommandeHorsMarcheSurCodeMarche(commande.exercice())) {
					isTypeAchatHorsMarcheDisabled = false;
				}
			}
		}

		return isTypeAchatHorsMarcheDisabled;
	}

	public boolean isTypeAchatHorsMarche() {
		EOTypeAchat leTypeAchat = getUnTypeAchatPossibleSelectionne();
		if (leTypeAchat != null && leTypeAchat.typaLibelle().equals(EOTypeAchat.MARCHE_NON_FORMALISE)) {
			isTypeAchatHorsMarche = true;
			if (attributionsValides != null && attributionsValides.count() > 0) {
				setAvertissement("Attention, ce code nomenclature est normalement associ&eacute; &agrave; un march&eacute;.");
			}
		}
		return isTypeAchatHorsMarche;
	}

	public void setIsTypeAchatHorsMarche(boolean isTypeAchatHorsMarche) {
		if (this.isTypeAchatHorsMarche != isTypeAchatHorsMarche) {
			if (isTypeAchatHorsMarche) {
				resetAttributions();
				resetTypesAchat();
				setUnTypeAchatPossibleSelectionne(FinderTypeAchat.getTypeAchat(laCommandeEnCours().editingContext(), EOTypeAchat.MARCHE_NON_FORMALISE));
			}
			this.isTypeAchatHorsMarche = isTypeAchatHorsMarche;
		}
	}

	public boolean isTypeAchatMonopoleDisabled() {
		boolean isTypeAchatMonopoleDisabled = true;
		NSArray<EOTypeAchat> typesAchat = typesAchatPossibles;
		EOCommande commande = laCommandeEnCours();
		if (commande.fournisseur() == null &&
				typesAchat != null && typesAchat.count() > 0) {
			@SuppressWarnings("unchecked")
			NSArray<String> libelles = (NSArray<String>) typesAchat.valueForKeyPath("typaLibelle");
			if (libelles.containsObject(EOTypeAchat.MONOPOLE)) {
				if (!isCmdeMarche || mySession().autoriserCommandeHorsMarcheSurCodeMarche(commande.exercice())) {
					isTypeAchatMonopoleDisabled = false;
				}
			}
		}

		return isTypeAchatMonopoleDisabled;
	}

	public boolean isTypeAchatMonopole() {
		EOTypeAchat leTypeAchat = getUnTypeAchatPossibleSelectionne();
		if (leTypeAchat != null && leTypeAchat.typaLibelle().equals(EOTypeAchat.MONOPOLE)) {
			isTypeAchatMonopole = true;
		}
		return isTypeAchatMonopole;
	}

	public void setIsTypeAchatMonopole(boolean isTypeAchatMonopole) {
		if (this.isTypeAchatMonopole != isTypeAchatMonopole) {
			if (isTypeAchatMonopole) {
				resetAttributions();
				resetTypesAchat();
				this.isTypeAchatMonopole = true;
				setUnTypeAchatPossibleSelectionne(FinderTypeAchat.getTypeAchat(laCommandeEnCours().editingContext(), EOTypeAchat.MONOPOLE));
			}
		}
	}

	public boolean isTypeAchat3cmpDisabled() {
		boolean isTypeAchat3cmpDisabled = true;
		NSArray<EOTypeAchat> typesAchat = typesAchatPossibles;
		EOCommande commande = laCommandeEnCours();
		if (commande.fournisseur() == null &&
				typesAchat != null && typesAchat.count() > 0) {
			@SuppressWarnings("unchecked")
			NSArray<String> libelles = (NSArray<String>) typesAchat.valueForKeyPath("typaLibelle");
			if (libelles.containsObject(EOTypeAchat.TROIS_CMP)) {
				if (!isCmdeMarche || mySession().autoriserCommandeHorsMarcheSurCodeMarche(commande.exercice())) {
					isTypeAchat3cmpDisabled = false;
				}
			}
		}
		return isTypeAchat3cmpDisabled;
	}

	public boolean isTypeAchat3cmp() {
		EOTypeAchat leTypeAchat = getUnTypeAchatPossibleSelectionne();
		if (leTypeAchat != null && leTypeAchat.typaLibelle().equals(EOTypeAchat.TROIS_CMP)) {
			isTypeAchat3cmp = true;
		}
		return isTypeAchat3cmp;
	}

	public void setIsTypeAchat3cmp(boolean isTypeAchat3cmp) {
		if (this.isTypeAchat3cmp != isTypeAchat3cmp) {
			if (isTypeAchat3cmp) {
				resetAttributions();
				resetTypesAchat();
				this.isTypeAchat3cmp = true;
				setUnTypeAchatPossibleSelectionne(FinderTypeAchat.getTypeAchat(laCommandeEnCours().editingContext(), EOTypeAchat.TROIS_CMP));
			}
		}
	}

	public boolean isTypeAchatSansAchatDisabled() {
		boolean isTypeAchatSansAchatDisabled = true;
		NSArray<EOTypeAchat> typesAchat = typesAchatPossibles;
		EOCommande commande = laCommandeEnCours();
		if (commande.fournisseur() == null &&
				typesAchat != null && typesAchat.count() > 0) {
			@SuppressWarnings("unchecked")
			NSArray<String> libelles = (NSArray<String>) typesAchat.valueForKeyPath("typaLibelle");
			if (libelles.containsObject(EOTypeAchat.SANS_ACHAT)) {
				if (!isCmdeMarche || mySession().autoriserCommandeHorsMarcheSurCodeMarche(commande.exercice())) {
					isTypeAchatSansAchatDisabled = false;
				}
			}
		}

		return isTypeAchatSansAchatDisabled;
	}

	public boolean isTypeAchatSansAchat() {
		EOTypeAchat leTypeAchat = getUnTypeAchatPossibleSelectionne();
		if (leTypeAchat != null && leTypeAchat.typaLibelle().equals(EOTypeAchat.SANS_ACHAT)) {
			isTypeAchatSansAchat = true;
		}
		return isTypeAchatSansAchat;
	}

	public void setIsTypeAchatSansAchat(boolean isTypeAchatSansAchat) {
		if (this.isTypeAchatSansAchat != isTypeAchatSansAchat) {
			if (isTypeAchatSansAchat) {
				resetAttributions();
				resetTypesAchat();
				this.isTypeAchatSansAchat = true;
				setUnTypeAchatPossibleSelectionne(FinderTypeAchat.getTypeAchat(laCommandeEnCours().editingContext(), EOTypeAchat.SANS_ACHAT));
			}
		}
	}

	public boolean isAfficherCatalogue() {
		boolean isAfficherCatalogue = false;
		EOAttribution attribution = getUneAttributionValideSelectionnee();
		if (attribution != null && uneAttributionValideSelectionnee.lot().isCatalogue()) {
			isAfficherCatalogue = true;
		}
		return isAfficherCatalogue;
	}

	public WOComponent visualiserCatalogue() {
		ArticleListeSelection nextPage = null;
		EOAttribution attribution = getUneAttributionValideSelectionnee();
		if (attribution != null) {
			WODisplayGroup dg = dgArticles();
			@SuppressWarnings("unchecked")
			NSMutableDictionary<String, Object> bdgs = dg.queryBindings();
			// Initalisation des bindings en fonction de la commande en cours
			bdgs.removeAllObjects();
			bdgs.setObjectForKey(laCommandeEnCours().exercice(), "exercice");
			bdgs.setObjectForKey(attribution, "attribution");
			NSArray<NSDictionary<String, Object>> lesArticles = FinderArticle.getRawRowArticles(laCommandeEnCours().editingContext(), bdgs);
			dg.setObjectArray(lesArticles);
			dg.setSelectedObjects(null);
			nextPage = (ArticleListeSelection) pageWithName("ArticleListeSelection");
			nextPage.initialiser();
		}
		return nextPage;
	}

	public boolean isAfficherListeFournisseur() {
		return isAfficherListeFournisseur;
	}

	public void setAfficherListeFournisseur(boolean isAfficherListeFournisseur) {
		this.isAfficherListeFournisseur = isAfficherListeFournisseur;
	}

	public boolean isAfficherLeFournisseur() {
		boolean isAfficherLeFournisseur = false;
		EOCommande commande = laCommandeEnCours();

		if (commande.fournisseur() != null ||
				(getUnFournisseurSelectionne() != null && lesFournisseurs != null && lesFournisseurs.count() == 1)) {
			isAfficherLeFournisseur = true;
		}
		return isAfficherLeFournisseur;
	}

	public boolean isAfficherPopupFournisseurs() {
		boolean isAfficherPopupFournisseurs = false;

		if (lesFournisseurs != null && lesFournisseurs.count() > 1) {
			isAfficherPopupFournisseurs = true;
		}
		return isAfficherPopupFournisseurs;
	}

	public boolean isPopupFournisseursDisabled() {
		boolean isPopupFournisseursDisabled = true;

		if (lesFournisseurs != null && lesFournisseurs.count() > 1) {
			isPopupFournisseursDisabled = false;
		}

		return isPopupFournisseursDisabled;
	}

	public boolean isAfficherRechercheFournisseur() {
		boolean isAfficherRechercheFournisseur = false;
		EOCommande commande = laCommandeEnCours();

		if (commande.fournisseur() == null && getUnCodeNomenclatureSelectionne() != null &&
				isCmdeMarche == false && (lesFournisseurs == null || lesFournisseurs.count() == 0)) {
			isAfficherRechercheFournisseur = true;
		}
		return isAfficherRechercheFournisseur;
	}

	public boolean isAfficherAvertissement() {
		boolean isAfficherAvertissement = false;
		if (avertissement != null && avertissement.length() > 0) {
			isAfficherAvertissement = true;
		}
		return isAfficherAvertissement;
	}

	public String getAvertissement() {
		return avertissement;
	}

	public void setAvertissement(String avertissement) {
		this.avertissement = avertissement;
	}

	public String getFilterTextAttribution() {
		return filterTextAttribution;
	}

	public void setFilterTextAttribution(String filterTextAttribution) {
		this.filterTextAttribution = filterTextAttribution;
	}

	public boolean isFournisseurDisabled() {
		boolean isFournisseurDisabled = true;
		EOCommande commande = laCommandeEnCours();
		if (commande.fournisseur() == null &&
				getUnCodeNomenclatureSelectionne() != null &&
				(getUnTypeAchatPossibleSelectionne() != null || getUneAttributionValideSelectionnee() != null)) {
			isFournisseurDisabled = false;
		}
		return isFournisseurDisabled;
	}

	public NSArray<NSDictionary<String, Object>> getLesFournisseurs() {
		return lesFournisseurs;
	}

	public void setLesFournisseurs(NSArray<NSDictionary<String, Object>> lesFournisseurs) {
		this.lesFournisseurs = lesFournisseurs;
	}

	public NSDictionary<String, Object> getUnFournisseur() {
		return unFournisseur;
	}

	public void setUnFournisseur(NSDictionary<String, Object> unFournisseur) {
		this.unFournisseur = unFournisseur;
	}

	public EOFournisseur getUnFournisseurSelectionne() {
		return unFournisseurSelectionne;
	}

	public void setUnFournisseurSelectionne(EOFournisseur unFournisseurSelectionne) {
		if ((this.unFournisseurSelectionne != null && this.unFournisseurSelectionne.equals(unFournisseurSelectionne) == false) ||
				(this.unFournisseurSelectionne == null && unFournisseurSelectionne != null)) {
			this.unFournisseurSelectionne = unFournisseurSelectionne;
		}
	}

	public NSDictionary<String, Object> getUnFournisseurDicoSelectionne() {
		return unFournisseurDicoSelectionne;
	}

	public void setUnFournisseurDicoSelectionne(NSDictionary<String, Object> unFournisseurDicoSelectionne) {
		this.unFournisseurDicoSelectionne = unFournisseurDicoSelectionne;
		if (unFournisseurDicoSelectionne != null) {
			String fouCode = (String) unFournisseurDicoSelectionne.objectForKey("CODE");
			EOFournisseur leFournisseur = FinderFournisseur.getFournisseur(laCommandeEnCours().editingContext(), fouCode);
			setUnFournisseurSelectionne(leFournisseur);
		}
		else {
			unFournisseurSelectionne = null;
		}
	}

	public String getFilterTextCodeNomenclature() {
		return filterTextCodeNomenclature;
	}

	public void setFilterTextCodeNomenclature(String filterTextCodeNomenclature) {
		this.filterTextCodeNomenclature = filterTextCodeNomenclature;
	}

	public EOCodeExer getUnCodeNomenclature() {
		return unCodeNomenclature;
	}

	public void setUnCodeNomenclature(EOCodeExer unCodeNomenclature) {
		this.unCodeNomenclature = unCodeNomenclature;
	}

	public EOCodeExer getUnCodeNomenclatureSelectionne() {
		return unCodeNomenclatureSelectionne;
	}

	public void setUnCodeNomenclatureSelectionne(EOCodeExer unCodeNomenclatureSelectionne) {
		if ((this.unCodeNomenclatureSelectionne != null && this.unCodeNomenclatureSelectionne.equals(unCodeNomenclatureSelectionne) == false) ||
				(this.unCodeNomenclatureSelectionne == null && unCodeNomenclatureSelectionne != null)) {
			this.unCodeNomenclatureSelectionne = unCodeNomenclatureSelectionne;
			fa.affecterCodeExer(newArticle, unCodeNomenclatureSelectionne);
		}
	}

	public EOCtrlSeuilMAPA getUnSeuilMAPASelectionne() {
		return unSeuilMAPASelectionne;
	}

	public void setUnSeuilMAPASelectionne(EOCtrlSeuilMAPA unSeuilMAPASelectionne) {
		if ((this.unSeuilMAPASelectionne != null && this.unSeuilMAPASelectionne.equals(unSeuilMAPASelectionne) == false) ||
				(this.unSeuilMAPASelectionne == null && unSeuilMAPASelectionne != null)) {
			this.unSeuilMAPASelectionne = unSeuilMAPASelectionne;
			setAvertissement(null);
			//				setUnCodeNomenclatureSelectionne(unSeuilMAPASelectionne.codeExer());
			if (unSeuilMAPASelectionne != null) {
				setUnCodeNomenclatureSelectionne(unSeuilMAPASelectionne.codeExer());
			}
		}
	}

	public boolean isInformationsDisabled() {
		boolean isInformationsDisabled = true;

		if (getUnCodeNomenclatureSelectionne() != null &&
				getUnFournisseurSelectionne() != null &&
				(getUnTypeAchatPossibleSelectionne() != null || getUneAttributionValideSelectionnee() != null)) {
			isInformationsDisabled = false;
		}

		return isInformationsDisabled;
	}

	public boolean isPrixDisabled() {
		boolean isPrixDisabled = true;
		EOArticle article = getNewArticle();
		if (article.artLibelle() != null && article.artLibelle().length() > 0) {
			isPrixDisabled = false;
		}

		return isPrixDisabled;
	}

	public String getRechercheRapide() {
		EOFournisseur fournisseur = getUnFournisseurSelectionne();
		if (fournisseur != null) {
			rechercheRapide = fournisseur.libelle();
		}
		return rechercheRapide;
	}

	public void setRechercheRapide(String rechercheRapide) {
		this.rechercheRapide = rechercheRapide;
	}

	public boolean isRecherchePersonneMorale() {
		return isRecherchePersonneMorale;
	}

	public void setIsRecherchePersonneMorale(boolean isRecherchePersonneMorale) {
		this.isRecherchePersonneMorale = isRecherchePersonneMorale;
	}

	public boolean isRechercheFournisseurInterne() {
		if (laCommandeEnCours().isEnregistrerPi()) {
			isRechercheFournisseurInterne = true;
		}
		return isRechercheFournisseurInterne;
	}

	public void setIsRechercheFournisseurInterne(boolean isRechercheFournisseurInterne) {
		this.isRechercheFournisseurInterne = isRechercheFournisseurInterne;
	}

	public EOAttribution getUneAttributionValide() {
		return uneAttributionValide;
	}

	public void setUneAttributionValide(EOAttribution uneAttributionValide) {
		this.uneAttributionValide = uneAttributionValide;
	}

	public EOAttribution getUneAttributionValideSelectionnee() {
		return uneAttributionValideSelectionnee;
	}

	public void setUneAttributionValideSelectionnee(EOAttribution uneAttributionValideSelectionnee) {
		if ((this.uneAttributionValideSelectionnee != null && this.uneAttributionValideSelectionnee.equals(uneAttributionValideSelectionnee) == false) ||
				(this.uneAttributionValideSelectionnee == null && uneAttributionValideSelectionnee != null)) {
			this.uneAttributionValideSelectionnee = uneAttributionValideSelectionnee;
			if (uneAttributionValideSelectionnee != null) {
				if (uneAttributionValideSelectionnee.lot().isCatalogue() == false) {
					setAvertissement(null);
					if (laCommandeEnCours().fournisseur() == null) {
						EOEditingContext ed = laCommandeEnCours().editingContext();
						NSDictionary<String, Object> bdgs = new NSDictionary<String, Object>(uneAttributionValideSelectionnee, "attribution");
						lesFournisseurs = FinderFournisseur.getRawRowFournisseurs(ed, bdgs);
						if (lesFournisseurs != null && lesFournisseurs.count() == 1) {
							NSDictionary<String, Object> fournisseur = lesFournisseurs.lastObject();
							String fouCode = (String) fournisseur.objectForKey("CODE");
							EOFournisseur leFournisseur = FinderFournisseur.getFournisseur(ed, fouCode);
							setUnFournisseurSelectionne(leFournisseur);
						}
						else {
							setAvertissement("Erreur : aucun fournisseur r&eacute;cup&eacute;r&eacute; pour l'attribution.");
						}
					}
				}
				else {
					// Cas d'une attribution catalogue ==> on ne peut pas creer d'article dessus
					setAvertissement("Cr&eacute;ation d'article interdite: cette attribution est restreinte &agrave; un catalogue.");
					lesFournisseurs = null;
					unFournisseurSelectionne = null;
					unFournisseurDicoSelectionne = null;
				}
			}
			else {
				lesFournisseurs = null;
				unFournisseurSelectionne = null;
				unFournisseurDicoSelectionne = null;
				setAvertissement(null);
			}
			fa.affecterTypeAchat(newArticle, null);
			fa.affecterAttribution(newArticle, uneAttributionValideSelectionnee);
		}
	}

	public EOTypeAchat getUnTypeAchatPossible() {
		return unTypeAchatPossible;
	}

	public void setUnTypeAchatPossible(EOTypeAchat unTypeAchatPossible) {
		this.unTypeAchatPossible = unTypeAchatPossible;
	}

	public EOTypeAchat getUnTypeAchatPossibleSelectionne() {
		return unTypeAchatPossibleSelectionne;
	}

	public void setUnTypeAchatPossibleSelectionne(EOTypeAchat unTypeAchatPossibleSelectionne) {
		if ((this.unTypeAchatPossibleSelectionne != null && this.unTypeAchatPossibleSelectionne.equals(unTypeAchatPossibleSelectionne) == false) ||
				(this.unTypeAchatPossibleSelectionne == null && unTypeAchatPossibleSelectionne != null)) {
			this.unTypeAchatPossibleSelectionne = unTypeAchatPossibleSelectionne;
			if (unTypeAchatPossibleSelectionne != null && laCommandeEnCours().fournisseur() == null) {
				String typaLibelle = unTypeAchatPossibleSelectionne.typaLibelle();
				if (typaLibelle.equals(EOTypeAchat.MONOPOLE) ||
						typaLibelle.equals(EOTypeAchat.TROIS_CMP)) {
					if (lesFournisseursPossiblesPourCodeExer == null || lesFournisseursPossiblesPourCodeExer.count() < 1) {
						setAvertissement("Vous ne pouvez pas utiliser ce code de nomenclature car il n'y a pas de fournisseur associ&eacute;.");
						unTypeAchatPossibleSelectionne = null;
					}
				}
			}
			fa.affecterAttribution(newArticle, null);
			fa.affecterTypeAchat(newArticle, unTypeAchatPossibleSelectionne);
		}
	}

	//	public String getNewArtLibelle() {
	//		return newArtLibelle;
	//	}
	//
	//	public void setNewArtLibelle(String newArtLibelle) {
	//		if (this.newArtLibelle != null && !this.newArtLibelle.equals(newArtLibelle) ||
	//				(this.newArtLibelle == null && newArtLibelle != null)) {
	//			this.newArtLibelle = newArtLibelle;
	//		}
	//	}
	public String getNewArtLibelle() {
		return getNewArticle().artLibelle();
	}

	public void setNewArtLibelle(String newArtLibelle) {
		getNewArticle().setArtLibelle(newArtLibelle);
	}

	public String getNewArtReference() {
		return getNewArticle().artReference();
	}

	public void setNewArtReference(String newArtReference) {
		getNewArticle().setArtReference(newArtReference);
	}

	//	public String getNewArtReference() {
	//		return newArtReference;
	//	}
	//
	//	public void setNewArtReference(String newArtReference) {
	//		if (this.newArtReference != null && this.newArtReference.equals(newArtReference) == false ||
	//				(this.newArtReference == null && newArtReference != null)) {
	//			this.newArtReference = newArtReference;
	//		}
	//	}

	public boolean isCatalogue() {
		return isCatalogue;
	}

	public void setIsCatalogue(boolean isCatalogue) {
		if (this.isCatalogue != isCatalogue) {
			this.isCatalogue = isCatalogue;
		}
	}

	private void verificationMAPA() {
		if (isTypeAchatHorsMarche() && getUnSeuilMAPASelectionne() != null) {
			NSArray<EOCtrlSeuilMAPA> lesSeuils = getLesSeuilsMAPA();
			NSArray<EOArticle> articles = laCommandeEnCours().articles();
			EOCodeExer codeExerSelectionne = getUnSeuilMAPASelectionne().codeExer();
			double montantHtDejaEngage = 0;
			//			EOQualifier qualCodeExer = EOQualifier.qualifierWithQualifierFormat("codeExer=%@", new NSArray(codeExerSelectionne));
			EOQualifier qualCodeExer = ERXQ.equals("codeExer", codeExerSelectionne);
			lesSeuils = EOQualifier.filteredArrayWithQualifier(lesSeuils, qualCodeExer);
			if (lesSeuils != null && lesSeuils.count() == 1) {
				EOCtrlSeuilMAPA unSeuil = (EOCtrlSeuilMAPA) lesSeuils.lastObject();
				montantHtDejaEngage = unSeuil.montantEngageHt().doubleValue();
				double montantHt = 0;
				if (articles != null && articles.count() > 0) {
					Enumeration<EOArticle> enumArticles = articles.objectEnumerator();
					while (enumArticles.hasMoreElements()) {
						EOArticle unArticle = enumArticles.nextElement();
						EOCodeExer unCodeExer = unArticle.codeExer();
						if (codeExerSelectionne.equals(unCodeExer) == true) {
							montantHt = montantHt + unArticle.artPrixTotalHt().doubleValue();
						}
					}
				}
				montantHt += getNewArticle().artPrixTotalHt().doubleValue();
				if (montantHt + montantHtDejaEngage > unSeuil.seuilMin().floatValue()) {
					setAvertissement("ATTENTION! Le seuil de " + unSeuil.seuilMin().floatValue() + "&euro; est d&eacute;pass&eacute; sur ce code de nomenclature. Vous entrez dans un M&agrave;PA!");
				}
				else {
					setAvertissement(null);
				}
			}
		}
		else {
			setAvertissement(null);
		}
	}

	//	public EOTva getUnTauxTVA() {
	//		return unTauxTVA;
	//	}
	//
	//	public void setUnTauxTVA(EOTva unTauxTVA) {
	//		this.unTauxTVA = unTauxTVA;
	//	}
	//

	public BigDecimal getNewArtPrixHt() {
		newArtPrixHt = newArticle.artPrixHt();
		return newArtPrixHt;
	}

	public void setNewArtPrixHt(BigDecimal newArtPrixHt) {
		if (!modificationEnCours && newArtPrixHt != null) {
			BigDecimal oldValue = this.newArtPrixHt;
			if ((oldValue != null && oldValue.compareTo(newArtPrixHt) != 0) ||
					(oldValue == null && newArtPrixHt != null)) {
				this.newArtPrixHt = newArtPrixHt;
				newArticle.setArtPrixHt(newArtPrixHt);
				modificationEnCours = true;
			}
		}
	}

	public EOTva getNewArtTva() {
		newArtTva = newArticle.tva();
		return newArtTva;
	}

	public void setNewArtTva(EOTva newArtTva) {
		if (!modificationEnCours && newArtTva != null) {
			EOTva oldValue = this.newArtTva;
			if ((oldValue != null && oldValue.equals(newArtTva) == false) ||
					(oldValue == null && newArtTva != null)) {
				this.newArtTva = newArtTva;
				newArticle.setTva(newArtTva);
				modificationEnCours = true;
			}
		}
	}

	public BigDecimal getNewArtQte() {
		newArtQte = newArticle.artQuantite();
		return newArtQte;
	}

	public void setNewArtQte(BigDecimal newArtQte) {
		if (!modificationEnCours && newArtQte != null) {
			BigDecimal oldValue = this.newArtQte;
			if ((oldValue != null && oldValue.compareTo(newArtQte) != 0) ||
					(oldValue == null && newArtQte != null)) {
				this.newArtQte = newArtQte;
				newArticle.setArtQuantite(newArtQte);
				modificationEnCours = true;
			}
		}
	}

	public BigDecimal getNewArtPrixTtc() {
		newArtPrixTtc = newArticle.artPrixTtc();
		return newArtPrixTtc;
	}

	public void setNewArtPrixTtc(BigDecimal newArtPrixTtc) {
		if (!modificationEnCours && newArtPrixTtc != null) {
			BigDecimal oldValue = this.newArtPrixTtc;
			if ((oldValue != null && oldValue.compareTo(newArtPrixTtc) != 0) ||
					(oldValue == null && newArtPrixTtc != null)) {
				this.newArtPrixTtc = newArtPrixTtc;
				newArticle.setArtPrixTtc(newArtPrixTtc);
				modificationEnCours = true;
			}
		}
	}

	//	public NSArray lesCodesNomenclature() {
	//		return lesCodesNomenclature;
	//	}

	public NSArray<EOCtrlSeuilMAPA> getLesSeuilsMAPA() {
		if (lesSeuilsMAPA == null) {
			lesSeuilsMAPA = FinderCtrlSeuilMAPA.getCtrlSeuilMAPAPourCommande(laCommandeEnCours().editingContext(), laCommandeEnCours());
			if (lesSeuilsMAPA != null && lesSeuilsMAPA.count() == 1) {
				setUnSeuilMAPASelectionne((EOCtrlSeuilMAPA) lesSeuilsMAPA.lastObject());
			}
		}
		return lesSeuilsMAPA;
	}

	public void setLesSeuilsMAPA(NSArray<EOCtrlSeuilMAPA> lesSeuilsMAPA) {
		this.lesSeuilsMAPA = lesSeuilsMAPA;
	}

	public EOCtrlSeuilMAPA getUnSeuilMAPA() {
		return unSeuilMAPA;
	}

	public void setUnSeuilMAPA(EOCtrlSeuilMAPA unSeuilMAPA) {
		this.unSeuilMAPA = unSeuilMAPA;
	}

	public NSArray<EOTva> lesTauxTVA() {
		if (lesTauxTVA == null) {
			lesTauxTVA = FinderTva.getTvas(newArticle.editingContext());
		}
		return lesTauxTVA;
	}

	public EOArticle getNewArticle() {
		return newArticle;
	}

	public void setNewArticle(EOArticle newArticle) {
		this.newArticle = newArticle;
		if (newArticle != null) {
			EOTva tva = newArticle.tva();
			if (newArtTva == null) {
				tva = (EOTva) lesTauxTVA().objectAtIndex(0);
				newArticle.setTva(tva);
			}
		}
	}

	public boolean isCocheFournisseurInterneDisabled() {
		boolean isCocheFournisseurInterneDisabled = false;
		EOCommande commande = laCommandeEnCours();
		if (commande != null && commande.isEnregistrerPi()) {
			isCocheFournisseurInterneDisabled = true;
		}
		return isCocheFournisseurInterneDisabled;
	}

	public String siret() {
		String siret = null;
		NSDictionary<String, Object> fournisseur = getUnFournisseur();
		if (fournisseur != null) {
			if (fournisseur.objectForKey("SIRET").equals(NSDictionary.NullValue) == false) {
				siret = (String) fournisseur.objectForKey("SIRET");
			}
		}
		return siret;
	}

	public String onClickDetailFournisseur() {
		String onClickDetailFournisseur = "Element.show($('" + getUnFournisseur().objectForKey("CODE") + "'));return false;";

		return onClickDetailFournisseur;
	}

	public String onClickHideDetailFournisseur() {
		String onClickHideDetailFournisseur = "Element.hide($('" + getUnFournisseur().objectForKey("CODE") + "'));return false;";

		return onClickHideDetailFournisseur;
	}

	public String detailFournisseurAdresse() {
		String detailFournisseurAdresse = "";
		NSDictionary<String, Object> fournisseur = getUnFournisseur();
		if (fournisseur.objectForKey("ADRESSE1") != null && fournisseur.objectForKey("ADRESSE1").equals(NSDictionary.NullValue) == false) {
			detailFournisseurAdresse += fournisseur.objectForKey("ADRESSE1") + " ";
		}
		if (fournisseur.objectForKey("ADRESSE2") != null && fournisseur.objectForKey("ADRESSE2").equals(NSDictionary.NullValue) == false) {
			detailFournisseurAdresse += fournisseur.objectForKey("ADRESSE2") + " ";
		}

		return detailFournisseurAdresse;
	}

	public String detailFournisseurCodePostal() {
		String detailFournisseurCodePostal = "";
		NSDictionary<String, Object> fournisseur = getUnFournisseur();
		if (fournisseur.objectForKey("CODEPOSTAL") != null && fournisseur.objectForKey("CODEPOSTAL").equals(NSDictionary.NullValue) == false) {
			detailFournisseurCodePostal += fournisseur.objectForKey("CODEPOSTAL");
		}

		return detailFournisseurCodePostal;
	}

	public String detailFournisseurVille() {
		String detailFournisseurVille = "";
		NSDictionary<String, Object> fournisseur = getUnFournisseur();
		if (fournisseur.objectForKey("VILLE") != null && fournisseur.objectForKey("VILLE").equals(NSDictionary.NullValue) == false) {
			detailFournisseurVille += fournisseur.objectForKey("VILLE");
		}

		return detailFournisseurVille;
	}

	public String detailFournisseurBP() {
		String detailFournisseurBP = "";
		NSDictionary<String, Object> fournisseur = getUnFournisseur();
		if (fournisseur.objectForKey("BP") != null && fournisseur.objectForKey("BP").equals(NSDictionary.NullValue) == false) {
			detailFournisseurBP += fournisseur.objectForKey("BP");
		}

		return detailFournisseurBP;
	}

	public String detailFournisseurPays() {
		String detailFournisseurPays = "";
		NSDictionary<String, Object> fournisseur = getUnFournisseur();
		if (fournisseur.objectForKey("PAYS") != null && fournisseur.objectForKey("PAYS").equals(NSDictionary.NullValue) == false) {
			detailFournisseurPays += fournisseur.objectForKey("PAYS");
		}

		return detailFournisseurPays;
	}

	public String detailFournisseurTels() {
		String detailFournisseurTels = "";
		NSDictionary<String, Object> fournisseur = getUnFournisseur();
		if (fournisseur.objectForKey("TELEPHONES") != null && fournisseur.objectForKey("TELEPHONES").equals(NSDictionary.NullValue) == false) {
			detailFournisseurTels += fournisseur.objectForKey("TELEPHONES");
		}

		return detailFournisseurTels;
	}

	public String detailFournisseurFaxs() {
		String detailFournisseurFaxs = "";
		NSDictionary<String, Object> fournisseur = getUnFournisseur();
		if (fournisseur.objectForKey("FAXS") != null && fournisseur.objectForKey("FAXS").equals(NSDictionary.NullValue) == false) {
			detailFournisseurFaxs += fournisseur.objectForKey("FAXS");
		}

		return detailFournisseurFaxs;
	}

	public String detailFournisseurRibs() {
		String detailFournisseurRibs = "";
		NSDictionary<String, Object> fournisseur = getUnFournisseur();
		if (fournisseur.objectForKey("RIBS") != null && fournisseur.objectForKey("RIBS").equals(NSDictionary.NullValue) == false) {
			detailFournisseurRibs += fournisseur.objectForKey("RIBS");
		}

		return detailFournisseurRibs;
	}

	public EOCodeExer b2bCodeExer() {
		return unCodeNomenclatureSelectionne;
	}

	public EOAttribution b2bAttribution() {
		return uneAttributionValideSelectionnee;
	}

	public EOTypeAchat b2bTypeAchat() {
		return unTypeAchatPossibleSelectionne;
	}

	public Integer b2bPersId() {
		return utilisateur().persId();
	}

	public void setB2bErreurMsg(String msg) {
		setAvertissement(msg);
	}

	public String uneAttributionValideLibelle() {
		if (uneAttributionValide == null) {
			return null;
		}
		String res = uneAttributionValide.libelle();
		if (uneAttributionValide.fournisseur() != null) {
			res = MyStringCtrl.cut(uneAttributionValide.fournisseur().fouNom(), 20) + " " + res;
		}
		return res;
	}

	//Rod b2b
	public NSArray<EOFournisB2bCxmlParam> b2bFournisParams() {
		EOFournisseur fournis = (getUneAttributionValideSelectionnee() != null ? getUneAttributionValideSelectionnee().fournisseur() : getUnFournisseurSelectionne());
		return EOFournisB2bCxmlParam.fetchAllValidesForFournisseur(edc(), fournis);
	}

	public Boolean isAfficherB2b() {
		if (isAfficherB2b == null) {
			isAfficherB2b = Boolean.valueOf(FinderUtilisateurFonction.getUtilisateurFonction(edc(), utilisateur(), EOFonction.FONCTION_B2B_CAT) != null);
		}
		if (isAfficherB2b.booleanValue()) {
			//si commande deja commencee et qu'on a des articles (qui ne sont pas b2b car sinon l'acces a cette page est desactive), on n'affiche pas le lien
			if (laCommandeEnCours().articles().count() > 0) {
				isAfficherB2b = Boolean.FALSE;
			}
		}
		return isAfficherB2b;
	}

	public Long commId() {
		return Long.valueOf(laCommandeEnCours().hashCode());
	}

	@Override
	public void validationFailedWithException(Throwable e, Object obj, String keyPath) {
		if (e instanceof ERXValidationException) {
			e.printStackTrace();
			ERXValidationException exception = (ERXValidationException) e;
			String template = ERXValidationFactory.defaultFactory().templateForException(exception);
			String message = ERXSimpleTemplateParser.sharedInstance().parseTemplateWithObject(template, null, exception.object());
			((CocktailAjaxSession) session()).addSimpleErrorMessage(message, "");
		}
		super.validationFailedWithException(e, obj, keyPath);
	}

	public EOFournis getFournis() {
		if (getUnFournisseurSelectionne() == null) {
			return null;
		}
		EOFournis fournis = EOFournis.fetchByKeyValue(getUnFournisseurSelectionne().editingContext(), EOFournis.FOU_ORDRE_KEY, getUnFournisseurSelectionne().fouOrdre());
		return fournis;
	}

	public Map<String, String> optionAttributesForSeuilsMapa() {
		HashMap<String, String> opts = new HashMap<String, String>();
		opts.put("data-txtValue", getUnSeuilMAPA().libelleSansMontant());
		return opts;
	}
}
